<?php

//	File to deal with the creation of the Order Custom Profile Fields order column.

//	Handle running this file by using SSI.php
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

//	Make sure that we have the package database functions.
if(!array_key_exists('db_add_column', $smcFunc))
	db_extend('packages');

//	We need to work out, if the 'position' column already exists, assume that it doesn't
$column_exsists = false;

//	Go through a list of columns from the 'custom_fields' to check for the 'position' colunm.
foreach ($smcFunc['db_list_columns']('{db_prefix}custom_fields') as $column)
{
	if($column == 'position')
		$column_exsists = true;
}

//	Set a 'current_position' value, it will be needed later on.
$current_pos = 0;

//	So, does the colunm already exist? If it doesn't then we need to create it.
if(empty($column_exsists))
{
	//	Firstly create the column.
	$column_info = array(
		'name' => 'position',
		'type' => 'smallint',
		'size' => '5',
		//	Just as a note to the Customization Team. This is actually totally unecessary, because the smf_db_add_column() function ignores empty default values. :P
		'default' => 0,
	);
	$smcFunc['db_add_column']('custom_fields', $column_info);
}
//	Otherwise, we have to assume that there is already some data and we have to do some nasty stuff to assure that its in the correct order again.
else
{
	//	Firstly lets get a list of current profile fields.
	$request = $smcFunc['db_query']('','
		SELECT position, id_field
		FROM {db_prefix}custom_fields
		WHERE position != {int:no_pos}
		ORDER BY position',
		array(
			'no_pos' => 0,
		)
	);
	
	//	Make an  array of current profile fields.
	$fields = array();
	while($row = $smcFunc['db_fetch_assoc']($request))
		$fields[$row['id_field']] = $row['position'];
	
	//	Free the db request.
	$smcFunc['db_free_result']($request);
	
	//	Go through the list of profile fields.
	foreach($fields as $id => $position)
	{
		$current_pos++;
		//	Is this field in the correct spot? If not, then we will need to fix it!
		if(!($current_pos == $position))
			$smcFunc['db_query']('','
				UPDATE {db_prefix}custom_fields
				SET position = {int:new_pos}
				WHERE id_field = {int:id}',
				array(
					'id' => $id,
					'new_pos' => $current_pos,
				)
			);
	}
}

//	Finally we can assign generic values to the rest of the rows/fields.
	
//	Firstly lets get a list of profile fields that don't have a position value.
$request = $smcFunc['db_query']('','
	SELECT id_field
	FROM {db_prefix}custom_fields	
	WHERE position = {int:no_pos}
	ORDER BY id_field',
	array(
		'no_pos' => 0,
	)
);
	
//	Make an array of the profile fields.
$fields = array();
while($row = $smcFunc['db_fetch_assoc']($request))
	$fields[] = $row['id_field'];

//	Free the db request.
$smcFunc['db_free_result']($request);

//	Go through the list of profile fields.
foreach($fields as $field_id)
{
	$current_pos++;
	//	Give this field a new position value.
	$smcFunc['db_query']('','
		UPDATE {db_prefix}custom_fields
		SET position = {int:position}
		WHERE id_field = {int:field_id}',
		array(
			'position' => $current_pos,
			'field_id' => $field_id,
		)
	);
}

//	Save the highest position as a setting in the database.
updateSettings(array('custom_profile_fields_pos_count' => $current_pos));

//	Show a confirmation message, if an upgrade through SSI.php was successful.
if(SMF == 'SSI')
   echo 'Database Updates Complete!';

?>